package waluty;

import static org.junit.Assert.*;
import org.junit.Test;

import java.math.BigDecimal;


public class WalutaTest {

	@Test
	public void testToString() {
		Waluta usd = new Waluta("USD", "dolar", new BigDecimal("4.2020"));
		assertEquals("USD (dolar): 4.2020", usd.toString());
	}
	
	@Test
	public void testPrzeliczNaZlote() {
		Waluta usd = new Waluta("USD", "dolar", new BigDecimal("4.2020"));
		BigDecimal kwota = new BigDecimal("100.00");
		BigDecimal oczekiwanyWynik = new BigDecimal("420.20");
		BigDecimal wynik = usd.przeliczNaZlote(kwota);
		assertEquals(oczekiwanyWynik, wynik);
	}
	
	@Test
	public void testPrzeliczNaZlote_Zero() {
		Waluta usd = new Waluta("USD", "dolar", new BigDecimal("4.2020"));
		BigDecimal wynik = usd.przeliczNaZlote(BigDecimal.ZERO);
		BigDecimal oczekiwanyWynik = new BigDecimal("0.00");
		assertEquals(oczekiwanyWynik, wynik);
	}
	
	@Test
	public void testPrzeliczNaZlote_Zaokraglanie() {
		Waluta waluta = new Waluta("ABC", "przykładowa waluta", new BigDecimal("2.2222"));
		BigDecimal kwota = new BigDecimal("3.00");
		BigDecimal oczekiwanyWynik = new BigDecimal("6.67");
		BigDecimal wynik = waluta.przeliczNaZlote(kwota);
		assertEquals(oczekiwanyWynik, wynik);
	}
	
	@Test
	public void testPrzeliczNaWalute() {
		Waluta usd = new Waluta("USD", "dolar", new BigDecimal("4.2020"));
		BigDecimal kwota = new BigDecimal("420.20");
		BigDecimal oczekiwanyWynik = new BigDecimal("100.00");
		BigDecimal wynik = usd.przeliczNaWalute(kwota);
		assertEquals(oczekiwanyWynik, wynik);
	}
	
	@Test
	public void testPrzeliczNaWalute_Zaokraglanie() {
		Waluta usd = new Waluta("ABC", "przykładowa waluta", new BigDecimal("3.0000"));
		BigDecimal kwota = new BigDecimal("200.00");
		BigDecimal oczekiwanyWynik = new BigDecimal("66.67");
		BigDecimal wynik = usd.przeliczNaWalute(kwota);
		assertEquals(oczekiwanyWynik, wynik);
	}

}
